package main

import (
	"crypto/hmac"
	"crypto/sha256"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
	"net/url"
	"strings"
	"time"
	//"net"
)

const (
	ApiKey    = "********************************"
	SecretKey = "********************************"
	appid     = "********"
	text      = "********************************"
)

type RequestParam struct {
	Common   map[string]string      `json:"common"`
	Business map[string]interface{} `json:"business"`
	Data     map[string]interface{} `json:"data"`
}

func Request() {

	var business = map[string]interface{}{
		"from": "**",
		"to":   "**",
	}

	var common = map[string]string{
		"app_id": appid,
	}

	var data = map[string]interface{}{
		"text": base64.StdEncoding.EncodeToString([]byte(text)),
	}

	var reqParam = RequestParam{
		Common:   common,
		Business: business,
		Data:     data,
	}
	body, _ := json.Marshal(&reqParam)
	fmt.Println("-------------------", string(body))
	server_url := "http://its-api-sg.xf-yun.com/v2/its"
	req, err := http.NewRequest("POST", server_url, strings.NewReader(string(body)))
	if err != nil {
		fmt.Println("err is is ", err)
	}
	client := &http.Client{}
	req.Header.Set("Content-Type", "application/json")
	u, _ := url.Parse(server_url)
	host := u.Host
	requestUri := u.RequestURI()
	assemblyRequestHeader("POST", req, host, requestUri)
	resp, err := client.Do(req)
	if err != nil {
		fmt.Println("err is", err)
		return
	}
	respBody, _ := ioutil.ReadAll(resp.Body)
	fmt.Println(string(respBody))
}

func assemblyRequestHeader(method string, req *http.Request, host, path string) {
	req.Header.Set("Host", host)
	currentTime := time.Now().UTC().Format(time.RFC1123)
	req.Header.Set("Date", currentTime)
	//digest := signBody(body)
	//req.Header.Set("Digest", "SHA-256="+digest)
	sign := generateSignature(req.Header.Get("Host"), req.Header.Get("Date"),
		method, path, "HTTP/1.1", SecretKey)
	var authHeader = `api_key="` + ApiKey + `", algorithm="hmac-sha256", headers="host date request-line", signature="` + sign + `"`
	fmt.Println(authHeader)
	req.Header.Set("Authorization", authHeader)
}

func generateSignature(host, date, httpMethod, requestUri, httpProto, secret string) string {

	var signatureStr string
	if len(host) != 0 {
		signatureStr = "host: " + host + "\n"
	}
	signatureStr += "date: " + date + "\n"

	signatureStr += httpMethod + " " + requestUri + " " + httpProto
	//signatureStr += "digest: " + digest
	fmt.Println(signatureStr)
	return hmacsign(signatureStr, secret)
}

func hmacsign(data, secret string) string {
	mac := hmac.New(sha256.New, []byte(secret))
	mac.Write([]byte(data))
	encodeData := mac.Sum(nil)
	return base64.StdEncoding.EncodeToString(encodeData)
}

func signBody(data []byte) string {
	sha := sha256.New()
	sha.Write(data)
	encodeData := sha.Sum(nil)
	return base64.StdEncoding.EncodeToString(encodeData)
}
func main() {
	Request()
}
